//	TangentPos.js
//	http://www.pictrix.jp/	Umezawa
//	05.4.28	11:02 AM


if ( documents.length > 0 && activeDocument.pathItems.length > 0 ){

	var m	= new Array( Array( 2 ), Array( 2 ), Array( 2 ), Array( 2 ), Array( 2 ), Array( 2 ) );
	var vpos	= new Array( Array( 2 ), Array( 2 ), Array( 2 ), Array( 2 ) );
	var tpos	= new Array( Array( 2 ), Array( 2 ), Array( 2 ), Array( 2 ) );
	var rpos	= new Array( Array( 2 ), Array( 2 ), Array( 2 ), Array( 2 ) );
	var vec1	= new Array( 2 );
	var vec2	= new Array( 2 );
	var np	= new Array( 2 );
	var dist	= new Array( 2 );
	var pos	= new Array( Array( 2 ) );

	selObj = activeDocument.selection;
	err = 0;

	if ( selObj.length != 2 ){
		err = 1;
		alert( "Select 2 objects" );
	}

	if ( ! err ){
		pathP = selObj[ 0 ].pathPoints;
		selV = 0;
		selT = 1;
		if ( pathP[ 0 ].selected == PathPointSelection.ANCHORPOINT ){
			set_pos( vpos, pathP, 0 );
		}
		else{
			 if ( pathP[ pathP.length - 1 ].selected == PathPointSelection.ANCHORPOINT ){
				set_pos( vpos, pathP, pathP.length - 1 );
			}
			else{
				pathP = selObj[ 1 ].pathPoints;
				selV = 1;
				selT = 0;
				if ( pathP[ 0 ].selected == PathPointSelection.ANCHORPOINT ){
					set_pos( vpos, pathP, 0 );
				}
				else{
					if ( pathP[ pathP.length - 1 ].selected == PathPointSelection.ANCHORPOINT ){
						set_pos( vpos, pathP, pathP.length - 1 );
					}
					else{
						err = 1;
						alert( "Select 1 edge point" );
					}
				}
			}
		}
	}

	if ( ! err ){
		pathP = selObj[ selT ].pathPoints;
		for ( i = 0; i < pathP.length; i++ ){
			if ( pathP[ i ].selected == PathPointSelection.RIGHTDIRECTION ){
				knotT1 = i;
				tpos[ 0 ] = pathP[ i ].anchor;
				tpos[ 1 ] = pathP[ i ].rightDirection;
				knotT2 = ( ( selObj[ selT ].closed == true ) && ( i == pathP.length -1 ) )? 0 : i + 1;
				tpos[ 2 ] = pathP[ knotT2 ].anchor;
				tpos[ 3 ] = pathP[ knotT2 ].leftDirection;
				break;
			}
		}
	}

	if ( ! err ){
		get_vec( vec1, vpos[ 0 ], vpos[ 1 ], vpos[ 2 ], vpos[ 3 ] );
		get_vec( vec2, tpos[ 0 ], tpos[ 1 ], tpos[ 2 ], tpos[ 3 ] );
		dot = VDOT( vec1, vec2 );
		if ( dot > 0.9999 || dot < -0.9999 ){
			np = tpos[ 0 ];
			npsw = 1;
		}
		else{
			get_vec( vec2, tpos[ 2 ], tpos[ 3 ], tpos[ 0 ], tpos[ 1 ] );
			dot = VDOT( vec1, vec2 );
			if ( dot > 0.9999 || dot < -0.9999 ){
				np = tpos[ 2 ];
				npsw = 1;
			}
			else{
				npsw = 0;
				angle = Math.atan2( vec1[ 1 ], vec1[ 0 ] );
				VROLL3( rpos, tpos, 4, -angle );
				t = getT_MaxMin( rpos, 1 );	
				if ( t == -1 ){
					err = 1;
					alert( "Tangential line is not found" );
				}
			}
		}
	}

	if ( ! err && ! npsw ){
		ans = confirm( "Add point to segment ?" );
		if ( ans == true ){
			getBezie_Point( m, t, tpos[ 0 ], tpos[ 1 ], tpos[ 2 ], tpos[ 3 ] );
			pathP[ knotT1 ].rightDirection = m[ 0 ];
			pathP[ knotT2 ].leftDirection = m[ 2 ];
			pos[ 0 ] = m[ 5 ];
			insertAnchor( knotT1, 1, selObj[ selT ], pos );
			knotT2 = knotT1 + 1;
			pathP[ knotT2 ].leftDirection = m[ 3 ];
			pathP[ knotT2 ].rightDirection = m[ 4 ];
			pathP[ knotT2 ].cornerType = PointType.SMOOTH;
			np = m[ 5 ];
			npsw = 1;
		}
	}

	if ( ! err ){
		ans = confirm( "Attach ?" );
		if ( ans == true ){
			if ( ! npsw ){
				getBezie_Pos( np, t, tpos[ 0 ], tpos[ 1 ], tpos[ 2 ], tpos[ 3 ] );
			}
			VSUB3( dist, np, vpos[ 0 ] );
			selObj[ selV ].translate( dist[ 0 ], dist[ 1 ] );
		}
	}
}



function get_vec( v, p1, h1, p2, h2 )
{
	var hand = new Array( 2 );
	if ( PosComp( p1, h1 ) ){
		if ( PosComp( p2, h2 ) ){
			hand = p2;
		}
		else{
			hand = h2;
		}
	}
	else{
		hand = h1;
	}
	VNORM3( v, hand, p1 );
}


function set_pos( ret, pathP, n )
{
	if ( n == 0 ){
		ret[ 0 ] = pathP[ n ].anchor;
		ret[ 1 ] = pathP[ n ].rightDirection;
		ret[ 2 ] = pathP[ n + 1 ].anchor;
		ret[ 3 ] = pathP[ n + 1 ].leftDirection;
	}
	else{
		ret[ 0 ] = pathP[ n ].anchor;
		ret[ 1 ] = pathP[ n ].leftDirection;
		ret[ 2 ] = pathP[ n - 1 ].anchor;
		ret[ 3 ] = pathP[ n - 1 ].rightDirection;
	}
}

function getT_MaxMin( ag, ax )
{
	var i, t, ti, tt, k, sw, maxt, mint;
	var np	= new Array( 2 );
	var maxp= new Array( 2 );
	var minp= new Array( 2 );
	var tp	= new Array( 2 );
	var p1	= ag[ 0 ];
	var h1	= ag[ 1 ];
	var p2	= ag[ 2 ];
	var h2	= ag[ 3 ];

	VCOPY( maxp , p1 );
	VCOPY( minp , p1 );
	mint = maxt = 0;
	for ( i = 1; i <= 20; i++ ){
		if ( i == 20 ){
			t = 1.0;
			VCOPY( np, p2 );
		}
		else{
			t = i / 20.0;
			getBezie_Pos( np, t, p1, h1, p2, h2 );
		}
		if ( maxp[ ax ] < np[ ax ] ){
			maxp[ ax ] = np[ ax ];
			maxt = i;
		}
		if ( minp[ ax ] > np[ ax ] ){
			minp[ ax ] = np[ ax ];
			mint = i;
		}
	}

	if ( ( mint == 0 ) || ( mint == 20 ) ){
		t =  ( maxt == 0 )? 0 : ( maxt - 1 ) / 20.0;
		sw = 1;
		VCOPY( tp, maxp );
	}
	else{
		t =  ( mint == 0 )? 0 : ( mint - 1 ) / 20.0;
		sw = 2;
		VCOPY( tp, minp );
	}

	k = -1;
	for ( i = 0; i <= 200; i++ ){
		ti = i / 2000.0;	// i * 2.0 / 20.0 / 200.0;
		tt = t + ti;
		if ( tt > 1.0 ) break;
		getBezie_Pos( np, tt, p1, h1, p2, h2 );
		switch ( sw ){
			case 1 :
				if ( tp[ ax ] < np[ ax ] ){
					tp[ ax ] = np[ ax ];
					k = tt;
				}
				break;
			case 2 :
				if ( tp[ ax ] > np[ ax ] ){
					tp[ ax ] = np[ ax ];
					k = tt;
					}
				break;
		}
	}
	return k;
}

function getBezie_Point( m, t, p1, h1, p2, h2 )
{
	m[ 0 ] = calcBezie_t( t, p1, h1 );		// p1 rightDirection
	m[ 1 ] = calcBezie_t( t, h1, h2 );
	m[ 2 ] = calcBezie_t( t, h2, p2 );		// p2 leftDirection
	m[ 3 ] = calcBezie_t( t, m[ 0 ], m[ 1 ] );	// new point leftDirection
	m[ 4 ] = calcBezie_t( t, m[ 1 ], m[ 2 ] );	// new point rightDirection
	m[ 5 ] = calcBezie_t( t, m[ 3 ], m[ 4 ] );	// new point
}

function calcBezie_t( t, n1, n2 )
{
	var wk = new Array( 2 );

	wk[ 0 ] =  ( n2[ 0 ] - n1[ 0 ] ) * t + n1[ 0 ];
	wk[ 1 ] =  ( n2[ 1 ] - n1[ 1 ] ) * t + n1[ 1 ];
	return wk;
}

function getBezie_Pos( np, t, p1, h1, p2, h2 )
{
	var t1, b1, b2, b3, b4;

	t1 = 1.0 - t;
	b1 = t1 * t1 * t1;
	b2 = 3 * t * t1 * t1;
	b3 = 3 * t * t * t1;
	b4 = t * t * t;
	np[ 0 ] = b1 * p1[ 0 ] + b2 * h1[ 0 ] + b3 * h2[ 0 ] + b4 * p2[ 0 ];
	np[ 1 ] = b1 * p1[ 1 ] + b2 * h1[ 1 ] + b3 * h2[ 1 ] + b4 * p2[ 1 ];
}

function insertAnchor( st, n, orgpath, newpos )
{
	var orgcnt		= orgpath.pathPoints.length;
	var orgLeft		= new Array( orgcnt );
	var orgRight		= new Array( orgcnt );
	var orgCorner	= new Array( orgcnt );
	var newAnchor	= new Array( orgcnt + n );
	var pp			= orgpath.pathPoints;
	var i, j, k;

	st++;
	j = 0;
	for ( i = 0; i < st; i++ ){
		newAnchor[ j ]	= pp[ i ].anchor;
		orgLeft[ j ]		= pp[ i ].leftDirection;
		orgRight[ j ]		= pp[ i ].rightDirection;
		orgCorner[ j++ ]	= pp[ i ].pointType;
	}
	for ( i = 0; i < n; i++ ){
		newAnchor[ j++ ]	= newpos[ i ];
	}
	for ( i = st; i < orgcnt; i++ ){
		newAnchor[ j ]	= pp[ i ].anchor;
		orgLeft[ j ]		= pp[ i ].leftDirection;
		orgRight[ j ]		= pp[ i ].rightDirection;
		orgCorner[ j++ ]	= pp[ i ].pointType;
	}
	orgpath.setEntirePath( newAnchor );
	k = 0;
	for ( i = 0; i < st; i++ ){
		pp[ k ].leftDirection	= orgLeft[ k ];
		pp[ k ].rightDirection	= orgRight[ k ];
		pp[ k ].pointType		= orgCorner[ k ];
		k++;
	}
	k += n;
	for ( i = st; i < orgcnt; i++ ){
		pp[ k ].leftDirection	= orgLeft[ k ];
		pp[ k ].rightDirection	= orgRight[ k ];
		pp[ k ].pointType		= orgCorner[ k ];
		k++;
	}
}

function VCOPY( t, s )
{
	t[ 0 ] = s[ 0 ];
	t[ 1 ] = s[ 1 ];
}

function VNORM3( v3, v1, v2 )
{
	VSUB3( v3, v1, v2 );
	VDIV( v3, VLEN( v3 ) );
}

function VSUB3( v3, v1, v2 )
{
	v3[ 0 ] = v1[ 0 ] - v2[ 0 ];
	v3[ 1 ] = v1[ 1 ] - v2[ 1 ];
}

function VDIV( v1, s )
{
	v1[ 0 ] = v1[ 0 ] / s;
	v1[ 1 ] = v1[ 1 ] / s;
}

function VLEN( v )
{
	return ( Math.sqrt( v[ 0 ] * v[ 0 ] + v[ 1 ] * v[ 1 ] ) );
}

function VDOT( v1, v2 )
{
	return ( v1[ 0 ] * v2[ 0 ] + v1[ 1 ] * v2[ 1 ] );
}

function PosComp( p1, p2 )
{
	return ( ( p1[ 0 ] == p2[ 0 ] ) && ( p1[ 1 ] == p2[ 1 ] ) );
}

function VROLL3( ret, v, n, rad )
{
	var i;

	for ( i = 0; i < n; i++ ){
		ret[ i ][ 0 ] = Math.cos( rad ) * v[ i ][ 0 ] - Math.sin( rad ) * v[ i ][ 1 ];
		ret[ i ][ 1 ] = Math.sin( rad ) * v[ i ][ 0 ] + Math.cos( rad ) * v[ i ][ 1 ];
	}
}

